/*
 * Copyright 2006 Helsinki Institute for Information Technology
 *
 * This file is a part of Fuego middleware.  Fuego middleware is free
 * software; you can redistribute it and/or modify it under the terms
 * of the MIT license, included as the file MIT-LICENSE in the Fuego
 * middleware source distribution.  If you did not receive the MIT
 * license with the distribution, write to the Fuego Core project at
 * fuego-core-users@hoslab.cs.helsinki.fi.
 */

package fuegocore.notify.comms;

import java.net.*;

import fuegocore.notify.profile.*;

/*
 * Ping for RTT, and heartbeat. Server module. Deprecated.
 */

public class PingChannelServer extends Thread {
    boolean alive = true;

    public PingChannelServer() {
    }

    public void shutdown() {
        alive = false;
    }

    public void run() {
        DatagramSocket socket = null;
        try {
            socket = new DatagramSocket(CommProfile.getPingPort());
            while (alive) {
                byte[] buf = new byte[1];
                DatagramPacket packet = new DatagramPacket(buf, buf.length);
                try {
                    synchronized (this) {
                        socket.receive(packet);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    packet = null;
                }
                if (packet != null) {
                    System.out.println("Received packet");
                    InetAddress address = packet.getAddress();
                    int port = packet.getPort();
                    packet = new DatagramPacket(buf, buf.length, address, port);
                    socket.send(packet);
                    System.out.println("Echoing packet");
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (socket != null) {
            socket.close();
        }
    }

    // Tester method for PingChannel
    public static void main(String[] args) {
        try {
            PingChannelServer pcs = new PingChannelServer();
            pcs.start();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
