/*
 * Copyright 2006 Helsinki Institute for Information Technology
 *
 * This file is a part of Fuego middleware.  Fuego middleware is free
 * software; you can redistribute it and/or modify it under the terms
 * of the MIT license, included as the file MIT-LICENSE in the Fuego
 * middleware source distribution.  If you did not receive the MIT
 * license with the distribution, write to the Fuego Core project at
 * fuego-core-users@hoslab.cs.helsinki.fi.
 */

package fuegocore.notify.comms;

import java.io.*;
import java.net.*;

import fuegocore.notify.core.client.*;

/**
 * TCP Socket test class
 */

public class TCPTimer {
    public TCPTimer(String host) {
        MicroRequest mr = new MicroRequest();
        mr.op = "test";
        mr.lastserver = "-";
        mr.id = "1234567";
        mr.count = 10;
        mr.payload = "Payload payload payload payload..";

        for (; ; ) {
            MicroRequest ret = call(host, mr);
            System.out.println(ret.toString());
        }

    }

    public static void main(String[] args) {
        TCPTimer TCPTimer1 = new TCPTimer(args[0]);
    }

    public MicroRequest call(String host, MicroRequest mq) {
        MicroRequest mr = new MicroRequest();
        String ret = null;
        byte[] record = null;

        try {
            long timer = System.currentTimeMillis();
            Socket conn = new Socket(host, 9000);

            OutputStream os = conn.getOutputStream();
            mq.persist(os, new Object());
            mr.resurrect(conn.getInputStream(), new Object());
            conn.close();
            long timer2 = System.currentTimeMillis();
            System.out.println("socket time :" + (timer2 - timer));
        } catch (Exception e) {
            e.printStackTrace();
        }
        return mr;
    }

}
