/*
 * Copyright 2006 Helsinki Institute for Information Technology
 *
 * This file is a part of Fuego middleware.  Fuego middleware is free
 * software; you can redistribute it and/or modify it under the terms
 * of the MIT license, included as the file MIT-LICENSE in the Fuego
 * middleware source distribution.  If you did not receive the MIT
 * license with the distribution, write to the Fuego Core project at
 * fuego-core-users@hoslab.cs.helsinki.fi.
 */

package fuegocore.notify.core;

import fuegocore.notify.core.session.*;

/**
 * EventBase is a simple event client that simplifies some of the
 * pub/sub API operations. This class provides support only for
 * a single event session.
 * Note that producers do not need to open a session (subscription semantics),
 * but subscribers have to do this.
 */

public class EventBase extends EventSession implements Notifiable {

    public EventBase() {
    }

    /**********************************************************************/

    /**
     * All subscribed events are delivered to this callback method.
     * @param n the incoming notification
     */
    public void notifyIncoming(Notification n) {
        // your code here
    }

    /**
     * This is the default callback method for receipts (acks).
     * @param n the incoming notification
     */
    public void notifyReceipt(Notification n) {
        // your code here
    }

    /**
     * Default failure handler.
     * @param n the incoming notification
     */
    public void notifyFailure(Notification n) {
        // your code here
    }
}
