package fuegocore.notify.core.client;

import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * Represents a service request for the micro version
 */
public class MicroRequest {
  public String op = "";
  public String id = "";
  public String lastserver = "-";
  public int count = 0;
  public int flag = 0;
  public Object payload = "";
  public String deviceId = "";

  /**
   * String representation
   * @return String
   */
  public String toString() {
    String ret = "";
    ret += "Op:" + op;
    ret += "Id:" + id;
    ret += "Lastserver:" + lastserver;
    ret += "DeviceId:" + deviceId;
    ret += "Count:" + count;
    ret += "Flag:" + flag;
    ret += "Payload:" + payload;
    return ret;
  }

  public byte[] persist(OutputStream out, Object din) throws IOException {
      DataOutputStream dout =
          new DataOutputStream(out);
      dout.writeUTF(op);
      dout.writeUTF(id);
      dout.writeUTF(lastserver);
      dout.writeUTF(deviceId);
      dout.writeInt(count);
      dout.writeInt(flag);
      dout.writeUTF(payload.toString());
      return null;
  }

  /**
   * Return the object as a byte array
   * @throws IOException
   * @return byte[]
   */
  public byte[] persist() throws IOException {
    ByteArrayOutputStream bout =
        new ByteArrayOutputStream();
    DataOutputStream dout =
        new DataOutputStream(bout);

    dout.writeUTF(op);
    dout.writeUTF(id);
    dout.writeUTF(lastserver);
    dout.writeUTF(deviceId);
    dout.writeInt(count);
    dout.writeInt(flag);
    dout.writeUTF(payload.toString());

    return bout.toByteArray();
  }

  /**
   * Decode message from a stream
   * @param din DataInputStream
   * @throws IOException
   */
  public void resurrect(DataInputStream din, Object xid) throws IOException {
    op = din.readUTF();
    id = din.readUTF();
    lastserver = din.readUTF();
    deviceId = din.readUTF();
    count = din.readInt();
    flag = din.readInt();
    payload = din.readUTF();
  }

 public void resurrect(InputStream din, Object xid) throws IOException {
   DataInputStream data = new DataInputStream(din);
   resurrect(data,xid);
 }

  /**
   * Decode message from a byte array
   * @param indata byte[]
   * @throws IOException
   */
  public void resurrect(byte[] indata) throws IOException {
    ByteArrayInputStream bin =
        new ByteArrayInputStream(indata);
    DataInputStream din =
        new DataInputStream(bin);
    op = din.readUTF();
    id = din.readUTF();
    lastserver = din.readUTF();
    deviceId = din.readUTF();
    count = din.readInt();
    flag = din.readInt();
    payload = din.readUTF();
    din.close();
  }
}
