/*
 * Copyright 2006 Helsinki Institute for Information Technology
 *
 * This file is a part of Fuego middleware.  Fuego middleware is free
 * software; you can redistribute it and/or modify it under the terms
 * of the MIT license, included as the file MIT-LICENSE in the Fuego
 * middleware source distribution.  If you did not receive the MIT
 * license with the distribution, write to the Fuego Core project at
 * fuego-core-users@hoslab.cs.helsinki.fi.
 */

package fuegocore.notify.core.serialization;

import java.io.*;

import fuegocore.util.xas.*;

public interface IEventSequenceSerializable {

    /**
     * Insert the filters to a SAX event sequence.
     * @param ser TypedXmlSerializer
     * @throws IOException
     */
    public void toEventSequence(TypedXmlSerializer ser) throws IOException;

    /**
     * Parse object from the given event sequence
     * @param es EventSequence
     * @return boolean
     */
    public boolean fromEventSequence(EventSequence es);

}
