/*
 * Copyright 2006 Helsinki Institute for Information Technology
 *
 * This file is a part of Fuego middleware.  Fuego middleware is free
 * software; you can redistribute it and/or modify it under the terms
 * of the MIT license, included as the file MIT-LICENSE in the Fuego
 * middleware source distribution.  If you did not receive the MIT
 * license with the distribution, write to the Fuego Core project at
 * fuego-core-users@hoslab.cs.helsinki.fi.
 */

package fuegocore.notify.core.server.engine;

import java.util.*;

import fuegocore.notify.core.server.manager.*;

/**
 * Defines the interfaces needed for handovers and mobile clients
 */
public interface IMobilityEngine {

    /**
     * Start mobility
     * @param client String
     * @param oset Vector
     * @param nset Vector
     * @return String
     */
    public String startMobility(String client, Vector oset, Vector nset);

    /**
     * Callback for expired sessions
     * @param session String
     */
    public void handoverFailure(String session);

    /**
     * Returns the handover manager
     * @return HandoverManager
     */
    public HandoverManager getHandoverManager();

    /**
     * Mobility handler
     * @param msg Message
     */
    public Object mobilityMessageHandler(fuegocore.message.service.Message msg);

}
