/*
 * Copyright 2006 Helsinki Institute for Information Technology
 *
 * This file is a part of Fuego middleware.  Fuego middleware is free
 * software; you can redistribute it and/or modify it under the terms
 * of the MIT license, included as the file MIT-LICENSE in the Fuego
 * middleware source distribution.  If you did not receive the MIT
 * license with the distribution, write to the Fuego Core project at
 * fuego-core-users@hoslab.cs.helsinki.fi.
 */

package fuegocore.notify.core.server.handlers;

import fuegocore.notify.core.client.*;

/**
 * Lightweight RPC handler interface
 */
public interface ILightweightRPCHandler {

    /** Lightweight RPC handler
     * @param mr the MicroRequest object that encapsulates the RPC parameters
     * @param address the address of the client
     * @return String the response
     */
    public Object processRequest(MicroRequest mr, String address);
}
