/*
 * Copyright 2006 Helsinki Institute for Information Technology
 *
 * This file is a part of Fuego middleware.  Fuego middleware is free
 * software; you can redistribute it and/or modify it under the terms
 * of the MIT license, included as the file MIT-LICENSE in the Fuego
 * middleware source distribution.  If you did not receive the MIT
 * license with the distribution, write to the Fuego Core project at
 * fuego-core-users@hoslab.cs.helsinki.fi.
 */

package fuegocore.notify.graphics;

/* Represents a plottable element with value and deviation.
 */
public class GraphObject {
    public double val;
    public double sd;
    public double prediction;
    public int marker = 0;
    public int pc = 0; // deprecated
    public boolean flip = false;

    public GraphObject(double v, double s, int p) {
        val = v;
        sd = s;
        pc = p;
    }

    public GraphObject(double v, double s, int m, int p) {
        val = v;
        sd = s;
        marker = m;
        pc = p;
    }

    public void setPrediction(double pred) {
        prediction = pred;
    }

}
