/*
 * Copyright 2006 Helsinki Institute for Information Technology
 *
 * This file is a part of Fuego middleware.  Fuego middleware is free
 * software; you can redistribute it and/or modify it under the terms
 * of the MIT license, included as the file MIT-LICENSE in the Fuego
 * middleware source distribution.  If you did not receive the MIT
 * license with the distribution, write to the Fuego Core project at
 * fuego-core-users@hoslab.cs.helsinki.fi.
 */

package fuegocore.notify.test.custom.core;

import java.util.*;

import fuegocore.notify.comms.*;
import fuegocore.notify.core.server.*;
import fuegocore.notify.core.server.ui.*;
import fuegocore.notify.util.*;

/**
 * Example of a custom router UI
 */
public class SimpleUI implements RouterUI {
    public static String TABLE_BG1 = "#9eceee";
    public static String BACKGROUND = "#ffffff";
    public static String SEL_COLOR = "#ffffff";
    public static String NOSEL_COLOR = "#efefff";
    public static String GREY_BAR = "#777777";
    public static String TABLE_ROW1 = "#eeeeee";
    public static String TABLE_ROW2 = "#cccccc";

    public String getUI(String s1, String s2, String params) {
        String ret = "";

        SimpleRouter engine = (SimpleRouter) EventServer.get().getRoutingEngine();

        RoutingTable tbl = (RoutingTable) engine.getTemplates();

        try {
            // Hashtable does not keep order so we use identifiers to match
            Enumeration k = tbl.getKeys();
            for (Enumeration e = tbl.getAll(); e.hasMoreElements(); ) {
                Object obj = e.nextElement();
                Vector ch = (Vector) obj;
                String name = (String) k.nextElement();
                if (ch != null) {
                    String id = name;
                    if (!s1.equals(id)) {
                        ret += "<tr bgcolor=\"" + TABLE_BG1 + "\"><td>";
                        ret += "<a href=\"http://localhost:" +
                                HTTPServlet.getPort() +
                                "/notify?id3=" + id + params +
                                "\" noborder>";
                        ret +=
                                "<img src=\"images/info.gif\" noborder align=center alt=\"open\"></a>";
                        ret += name;
                        ret += "</td></tr>";
                    } else { // selected entry
                        ret += "<tr bgcolor=\"" + SEL_COLOR +
                                "\"><td align=left>";
                        ret += "<a href=\"http://localhost:" +
                                HTTPServlet.getPort() +
                                "/notify?id3=" + params +
                                "\" noborder>";
                        ret += "<img src=\"images/info.gif\" noborder align=left valign=center alt=\"close\"></a>";
                        ret += name;
                        ret += ManagementUI.printFilterTable(ch);
                        ret += "</td></tr>";
                    }
                    // black border
                    ret +=
                            "<tr bgcolor=\"#000000\" height=1><td height=1></td></tr>";
                }
            }
        } catch (Exception e) {
            ret = "Exception occurred: " + e;
            e.printStackTrace();
        }
        return ret;
    }
}
