/*
 * Copyright 2006 Helsinki Institute for Information Technology
 *
 * This file is a part of Fuego middleware.  Fuego middleware is free
 * software; you can redistribute it and/or modify it under the terms
 * of the MIT license, included as the file MIT-LICENSE in the Fuego
 * middleware source distribution.  If you did not receive the MIT
 * license with the distribution, write to the Fuego Core project at
 * fuego-core-users@hoslab.cs.helsinki.fi.
 */

package fuegocore.notify.util;

import java.io.*;

/**
 * A simple interface for building persistent objects on
 * platforms where serialization is not available.
 */
public interface Persistent {

    /**
     * Called to persist an object.
     * @throws IOException
     * @return byte[]
     */
    byte[] persist() throws IOException;

    /**
     * Called to resurrect a persistent object.
     * @param data byte[]
     * @throws IOException
     */
    void resurrect(byte[] data) throws IOException;
}
