/*
 * Copyright 2006 Helsinki Institute for Information Technology
 *
 * This file is a part of Fuego middleware.  Fuego middleware is free
 * software; you can redistribute it and/or modify it under the terms
 * of the MIT license, included as the file MIT-LICENSE in the Fuego
 * middleware source distribution.  If you did not receive the MIT
 * license with the distribution, write to the Fuego Core project at
 * fuego-core-users@hoslab.cs.helsinki.fi.
 */

package fuegocore.notify.util;

import java.io.*;
import fuegocore.util.ExtUtil;

/**
 * Read file helper class
 */

public class ReadFile {

    BufferedReader in;

    public ReadFile(String s) {
        try {
            in = new BufferedReader(new InputStreamReader
                                    (ExtUtil.getFileOrResource("notify", s)));
        } catch (Exception e) {
            Log.write("Error opening file for reading:" + s);
            e.printStackTrace();
        }
    }

    public String readLine() {
        if (in == null) {
            return null;
        }
        String s = null;
        try {
            s = in.readLine();
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("Read:" + s);
        return s;
    }

    public String readValue(String val) {
        if (in == null) {
            return null;
        }
        String str = null;
        try {
            str = in.readLine();
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (str == null) {
            return null;
        }
        System.out.println("Read:" + str);
        return Auxil.getValue(str, val);
    }

    public void close() {
        try {
            if (in != null) {
                in.close();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
